# Source code for api.datastores.v1.store.store

    """Autogenerated API"""
    import requests
    from argus_cli.plugin import register_command

    @register_command(extending=('datastores','v1','store',''))
    def get_entries_from_store_simplified(dataStore: str, customerID: list = None, key: list = None, offset: int = 0, limit: int = 25, includeDeleted: bool = 'True',json: bool = True, verify: bool = True, apiKey: str = "", authentication: dict = {}) -> dict:
        """Returns datastore entries for the specified store, matching query parameters. (PUBLIC)

        :param str dataStore: Store name
        :param list customerID: Limit search to entries for the specified customers
        :param list key: Limit search to the specified entry keys
        :param int offset: Skip a number of results
        :param int limit: Maximum number of returned results
        :param bool includeDeleted: Include deleted/expired keys
        :raises AuthenticationFailedException: on 401
        :raises ValidationErrorException: on 412
        :raises AccessDeniedException: on 403
        :raises StoreNotFoundException: on 404
        :returns: {"offset": 357, "limit": 637, "responseCode": 200, "count": 464, "data": [{"dataStoreName": "Speak could ahead win big they member.", "lastUpdatedTimestamp": 1302479283, "lastUpdatedByUser": {"id": 239, "customerID": 722, "userName": "wendynorman", "name": "Gabriela Waller"}, "key": "Democrat task thing.", "value": "Economic evening one manage go.", "flags": ["DELETED"]}], "metaData": {"additionalProperties": {}}, "messages": [{"message": "Nearly think prevent together thousand.", "messageTemplate": "Artist establish send close toward still rather.", "field": "Ground than friend find car whom offer huge.", "parameter": {}, "timestamp": 1160534531}], "currentPage": 442, "size": 43}
        """
        from requests import get
        from argus_api.exceptions import http

        url = "https://osl-argus-trunk-web1.mnemonic.no/web/api/datastores/v1/store/{dataStore}".format(dataStore=dataStore)
        headers = {
            'Content-Type': 'application/json',
            'User-Agent': 'ArgusToolbelt/1.0'
        }

        if apiKey:
            headers["Argus-API-Key"] = apiKey
        elif authentication and isinstance(authentication, dict):
            headers.update(authentication)
        elif callable(authentication):
            headers.update(authentication(url))

        body = {}

        if offset:
            body.update({"offset": offset})

        if limit:
            body.update({"limit": limit})

        if includeDeleted:
            body.update({"includeDeleted": includeDeleted})

        if customerID:
            body.update({"customerID": customerID})

        if key:
            body.update({"key": key})

        response = get(url, json=body if body else None, verify=verify, headers=headers)

        errors = []
        if response.status_code == 401:
            raise http.AuthenticationFailedException(response)
        elif response.status_code == 403:
            raise http.AccessDeniedException(response)
        elif response.status_code == 412:
            raise http.ValidationErrorException(response)
        elif response.status_code == 404:
            raise http.ObjectNotFoundException(response)

        return response.json() if json else response

    @register_command(extending=('datastores','v1','store',''))
    def put_data_store_entries(dataStore: str, customerID: int = None, entries: list = None,json: bool = True, verify: bool = True, apiKey: str = "", authentication: dict = {}) -> dict:
        """Updates the provided datastore entries for the specified store. (PUBLIC)

        :param str dataStore: Store name
        :param int customerID: ID of customer to bind data to. If not set, default is to bind to the current users customer (or none, if datastore is global)
        :param list entries: Entries to add
        :raises AuthenticationFailedException: on 401
        :raises ValidationErrorException: on 412
        :raises AccessDeniedException: on 403
        :raises StoreNotFoundException: on 404
        :returns: {"offset": 693, "limit": 937, "responseCode": 200, "count": 347, "data": [{"dataStoreName": "Character group class listen.", "lastUpdatedTimestamp": 194121165, "lastUpdatedByUser": {"id": 818, "customerID": 875, "userName": "mary57", "name": "Timothy Arnold"}, "key": "Foreign boy room.", "value": "Spend particularly career role pick.", "flags": ["DELETED"]}], "metaData": {"additionalProperties": {}}, "messages": [{"message": "Pressure officer TV who approach.", "messageTemplate": "Manager discover force case simply color born.", "field": "Chair thought perhaps large talk woman voice human.", "parameter": {}, "timestamp": 898504134}], "currentPage": 193, "size": 620}
        """
        from requests import put
        from argus_api.exceptions import http

        url = "https://osl-argus-trunk-web1.mnemonic.no/web/api/datastores/v1/store/{dataStore}".format(dataStore=dataStore)
        headers = {
            'Content-Type': 'application/json',
            'User-Agent': 'ArgusToolbelt/1.0'
        }

        if apiKey:
            headers["Argus-API-Key"] = apiKey
        elif authentication and isinstance(authentication, dict):
            headers.update(authentication)
        elif callable(authentication):
            headers.update(authentication(url))

        body = {}

        if customerID:
            body.update({"customerID": customerID})

        if entries:
            body.update({"entries": entries})

        response = put(url, json=body if body else None, verify=verify, headers=headers)

        errors = []
        if response.status_code == 401:
            raise http.AuthenticationFailedException(response)
        elif response.status_code == 403:
            raise http.AccessDeniedException(response)
        elif response.status_code == 412:
            raise http.ValidationErrorException(response)
        elif response.status_code == 404:
            raise http.ObjectNotFoundException(response)

        return response.json() if json else response

    @register_command(extending=('datastores','v1','store',''))
    def delete_data_store_entries(dataStore: str, key: list = None, customerID: int = None,json: bool = True, verify: bool = True, apiKey: str = "", authentication: dict = {}) -> dict:
        """Deletes the specified datastore entries for the specified store. (PUBLIC)

        :param str dataStore: Store name
        :param list key: Datastore keys to delete
        :param int customerID: Specify datastore to delete entries from (default is users customer)
        :raises AuthenticationFailedException: on 401
        :raises ValidationErrorException: on 412
        :raises AccessDeniedException: on 403
        :raises StoreNotFoundException: on 404
        :returns: {"offset": 342, "limit": 169, "responseCode": 200, "count": 511, "data": [{"dataStoreName": "Through whom capital culture decade another.", "lastUpdatedTimestamp": 1204069840, "lastUpdatedByUser": {"id": 833, "customerID": 42, "userName": "todd57", "name": "Andrea Schneider"}, "key": "Fly cold center politics former stay.", "value": "Special itself bad billion.", "flags": ["DELETED"]}], "metaData": {"additionalProperties": {}}, "messages": [{"message": "Include story quality process itself.", "messageTemplate": "Feel full about.", "field": "The executive appear.", "parameter": {}, "timestamp": 101179152}], "currentPage": 477, "size": 122}
        """
        from requests import delete
        from argus_api.exceptions import http

        url = "https://osl-argus-trunk-web1.mnemonic.no/web/api/datastores/v1/store/{dataStore}".format(dataStore=dataStore)
        headers = {
            'Content-Type': 'application/json',
            'User-Agent': 'ArgusToolbelt/1.0'
        }

        if apiKey:
            headers["Argus-API-Key"] = apiKey
        elif authentication and isinstance(authentication, dict):
            headers.update(authentication)
        elif callable(authentication):
            headers.update(authentication(url))

        body = {}

        if key:
            body.update({"key": key})

        if customerID:
            body.update({"customerID": customerID})

        response = delete(url, json=body if body else None, verify=verify, headers=headers)

        errors = []
        if response.status_code == 401:
            raise http.AuthenticationFailedException(response)
        elif response.status_code == 403:
            raise http.AccessDeniedException(response)
        elif response.status_code == 412:
            raise http.ValidationErrorException(response)
        elif response.status_code == 404:
            raise http.ObjectNotFoundException(response)

        return response.json() if json else response

    @register_command(extending=('datastores','v1','store',''))
    def get_entries_from_store(dataStore: str, limit: int = None, offset: int = None, subCriteria: list = None, customerID: list = None, userID: list = None, key: list = None, fromKey: str = None, toKey: str = None, startTimestamp: int = None, endTimestamp: int = None, sortBy: list = None, includeFlags: list = None, excludeFlags: list = None, includeDeleted: bool = 'False', exclude: bool = 'False', required: bool = 'False',json: bool = True, verify: bool = True, apiKey: str = "", authentication: dict = {}) -> dict:
        """Returns datastore entries for the specified store, matching the search criteria. (PUBLIC)

        :param str dataStore: Store name
        :param int limit: Set this value to set max number of results. By default, no restriction on result set size.
        :param int offset: Set this value to skip the first (offset) objects. By default, return result from first object.
        :param list subCriteria:
        :param list customerID: Restrict search to data belonging to specified customers.
        :param list userID: Restrict search to entries which was last updated by specified users.
        :param list key: Restrict search to the specified key (entries).
        :param str fromKey: Restrict search to entries (map keys) which are greater than this key (including, by lexical order).
        :param str toKey: Restrict search to entries (map keys) which are less than this key (including, by lexical order).
        :param int startTimestamp: Restrict search to entries which are last updated after this timestamp (including).
        :param int endTimestamp: Restrict search to entries which are last updated before this timestamp (including).
        :param list sortBy: List of properties to sort by (prefix with "-" to sort descending).
        :param list includeFlags: Only include objects which have includeFlags set.
        :param list excludeFlags: Exclude objects which have excludeFlags set.
        :param bool includeDeleted: Set to true to include deleted objects. By default, exclude deleted objects.
        :param bool exclude: Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.
        :param bool required: Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).
        :raises AuthenticationFailedException: on 401
        :raises ValidationErrorException: on 412
        :raises AccessDeniedException: on 403
        :raises StoreNotFoundException: on 404
        :returns: {"offset": 415, "limit": 606, "responseCode": 200, "count": 937, "data": [{"dataStoreName": "Trip treatment admit leader appear agreement claim.", "lastUpdatedTimestamp": 1334306228, "lastUpdatedByUser": {"id": 480, "customerID": 425, "userName": "elizabeth02", "name": "Joseph Graham"}, "key": "Amount subject phone.", "value": "Environment century against necessary west sea west.", "flags": ["DELETED"]}], "metaData": {"additionalProperties": {}}, "messages": [{"message": "Late Congress conference.", "messageTemplate": "Produce fear woman imagine wish each stock bring.", "field": "Stop program material ago enjoy drug.", "parameter": {}, "timestamp": 702332927}], "currentPage": 754, "size": 532}
        """
        from requests import post
        from argus_api.exceptions import http

        url = "https://osl-argus-trunk-web1.mnemonic.no/web/api/datastores/v1/store/{dataStore}/search".format(dataStore=dataStore)
        headers = {
            'Content-Type': 'application/json',
            'User-Agent': 'ArgusToolbelt/1.0'
        }

        if apiKey:
            headers["Argus-API-Key"] = apiKey
        elif authentication and isinstance(authentication, dict):
            headers.update(authentication)
        elif callable(authentication):
            headers.update(authentication(url))

        body = {}

        if limit:
            body.update({"limit": limit})

        if offset:
            body.update({"offset": offset})

        if includeDeleted:
            body.update({"includeDeleted": includeDeleted})

        if subCriteria:
            body.update({"subCriteria": subCriteria})

        if exclude:
            body.update({"exclude": exclude})

        if required:
            body.update({"required": required})

        if customerID:
            body.update({"customerID": customerID})

        if userID:
            body.update({"userID": userID})

        if key:
            body.update({"key": key})

        if fromKey:
            body.update({"fromKey": fromKey})

        if toKey:
            body.update({"toKey": toKey})

        if startTimestamp:
            body.update({"startTimestamp": startTimestamp})

        if endTimestamp:
            body.update({"endTimestamp": endTimestamp})

        if sortBy:
            body.update({"sortBy": sortBy})

        if includeFlags:
            body.update({"includeFlags": includeFlags})

        if excludeFlags:
            body.update({"excludeFlags": excludeFlags})

        response = post(url, json=body if body else None, verify=verify, headers=headers)

        errors = []
        if response.status_code == 401:
            raise http.AuthenticationFailedException(response)
        elif response.status_code == 403:
            raise http.AccessDeniedException(response)
        elif response.status_code == 412:
            raise http.ValidationErrorException(response)
        elif response.status_code == 404:
            raise http.ObjectNotFoundException(response)

        return response.json() if json else response

    @register_command(extending=('datastores','v1','store',''))
    def get_single_entry(dataStore: str, key: str, customerID: int = None, includeDeleted: bool = 'True',json: bool = True, verify: bool = True, apiKey: str = "", authentication: dict = {}) -> dict:
        """Returns the specified datastore entry for the specified store, or null if it does not exist (PUBLIC)

        :param str dataStore: Store name
        :param str key: Key to search
        :param int customerID: Search specified customer store for this key (default is users customer)
        :param bool includeDeleted: Include deleted/expired key
        :raises AuthenticationFailedException: on 401
        :raises ValidationErrorException: on 412
        :raises AccessDeniedException: on 403
        :raises StoreNotFoundException: on 404
        :returns: {"offset": 250, "limit": 164, "responseCode": 200, "count": 985, "metaData": {"additionalProperties": {}}, "messages": [{"message": "Win enjoy threat.", "messageTemplate": "Worry reveal subject owner.", "field": "Crime building much type.", "parameter": {}, "timestamp": 1129090915}], "currentPage": 410, "size": 585}
        """
        from requests import get
        from argus_api.exceptions import http

        url = "https://osl-argus-trunk-web1.mnemonic.no/web/api/datastores/v1/store/{dataStore}/{key}".format(dataStore=dataStore, key=key)
        headers = {
            'Content-Type': 'application/json',
            'User-Agent': 'ArgusToolbelt/1.0'
        }

        if apiKey:
            headers["Argus-API-Key"] = apiKey
        elif authentication and isinstance(authentication, dict):
            headers.update(authentication)
        elif callable(authentication):
            headers.update(authentication(url))

        body = {}

        if includeDeleted:
            body.update({"includeDeleted": includeDeleted})

        if customerID:
            body.update({"customerID": customerID})

        response = get(url, json=body if body else None, verify=verify, headers=headers)

        errors = []
        if response.status_code == 401:
            raise http.AuthenticationFailedException(response)
        elif response.status_code == 403:
            raise http.AccessDeniedException(response)
        elif response.status_code == 412:
            raise http.ValidationErrorException(response)
        elif response.status_code == 404:
            raise http.ObjectNotFoundException(response)

        return response.json() if json else response

    @register_command(extending=('datastores','v1','store',''))
    def put_single_data_store_entry(dataStore: str, key: str, customerID: int = None,json: bool = True, verify: bool = True, apiKey: str = "", authentication: dict = {}) -> dict:
        """Adds the provided datastore entry for the specified store. To use for lists (key, no value) (PUBLIC)

        :param str dataStore: Store name
        :param str key: Datastore key to set
        :param int customerID: Specify datastore to put entry to (default is users customer)
        :raises AuthenticationFailedException: on 401
        :raises ValidationErrorException: on 412
        :raises AccessDeniedException: on 403
        :raises StoreNotFoundException: on 404
        :returns: {"offset": 490, "limit": 874, "responseCode": 200, "count": 932, "metaData": {"additionalProperties": {}}, "messages": [{"message": "Threat space test fear vote heart.", "messageTemplate": "Experience little article laugh actually listen task magazine.", "field": "Other fear point.", "parameter": {}, "timestamp": 730228335}], "currentPage": 81, "size": 633}
        """
        from requests import put
        from argus_api.exceptions import http

        url = "https://osl-argus-trunk-web1.mnemonic.no/web/api/datastores/v1/store/{dataStore}/{key}".format(dataStore=dataStore, key=key)
        headers = {
            'Content-Type': 'application/json',
            'User-Agent': 'ArgusToolbelt/1.0'
        }

        if apiKey:
            headers["Argus-API-Key"] = apiKey
        elif authentication and isinstance(authentication, dict):
            headers.update(authentication)
        elif callable(authentication):
            headers.update(authentication(url))

        body = {}

        if customerID:
            body.update({"customerID": customerID})

        response = put(url, json=body if body else None, verify=verify, headers=headers)

        errors = []
        if response.status_code == 401:
            raise http.AuthenticationFailedException(response)
        elif response.status_code == 403:
            raise http.AccessDeniedException(response)
        elif response.status_code == 412:
            raise http.ValidationErrorException(response)
        elif response.status_code == 404:
            raise http.ObjectNotFoundException(response)

        return response.json() if json else response